//
//  Ptr.swift
//  CGPathApply
//
//  Created by Gary Liddle on 06/03/2015.
//  Copyright (c) 2015 Gary Liddle. All rights reserved.
//

/*
 * this class is here mainly to de-clutter all the pointer making code
 * and pointer freeing code
 * and to make sure the destroy and dealloc occur
 */

import Foundation

class Ptr<T> {
    
    var ptr: UnsafeMutablePointer<T> = nil;
    
    init(value v: T) {
        ptr = UnsafeMutablePointer<T>.alloc(1);
        ptr.initialize(v);
    }
    
    func cast<U>(t: U.Type) -> U {
        return unsafeBitCast(ptr, t.self);
    }
    
    deinit {
        if (ptr != nil) {
            ptr.destroy()
            ptr.dealloc(1);
        }
    }
}