//
//  get_func_impl.m
//  CGPathApply
//
//  Created by Gary Liddle on 05/03/2015.
//  Copyright (c) 2015 Gary Liddle. All rights reserved.
//

#import <Foundation/Foundation.h>

/*
 * this code taken from https://github.com/rodionovd/SWRoute/wiki/Function-hooking-in-Swift
 */

#define kObjectFieldOffset sizeof(uintptr_t)

struct swift_func_object {
    uintptr_t *original_type_ptr;
#if defined(__x86_64__)
    uintptr_t *unknown0;
#else
    uintptr_t *unknown0, *unknown1;
#endif
    uintptr_t function_address;
    uintptr_t *self;
};


uintptr_t _rd_get_func_impl(void *func)
{
    struct swift_func_object *obj = (struct swift_func_object *)*(uintptr_t *)(func + kObjectFieldOffset);
    
    //printf("-->Address of C-Func %lx unk=%lx ori=%lx<--\n", obj->function_address, obj->unknown0, obj->original_type_ptr);
    return obj->function_address;
}

/*
 * The above code only works for functions not in a class and not using generic typed inputs.
 * for generic typed inputs we seem to have to indirect via the unknown0
 * but I haven't got a clue how to return a generic typed return value
 */
uintptr_t _rd_get_func_implT(void *func)
{
    
    struct swift_func_object *o1 = (struct swift_func_object *)*(uintptr_t *)(func + kObjectFieldOffset);
    struct swift_func_object *o2 = (struct swift_func_object *)o1->unknown0;

    //printf("-->AddressT of C-Func %lx unk=%lx orig=%lx<--\n", o2->function_address, o1->unknown0, o1->original_type_ptr);
    return o2->function_address;

    
}